'###################################################
'#    COMEC openvpn configuration installer        #
'###################################################

' ###### use.inc (useLibs): uac #########
'
'$$ use util

' ----------------------------------------------------
'    Windows 7. 
'    PrivDir     . 
'       /uac 
'         .
'
'  relaunch     (code, msg)
'       returnOk  returnErr
' ----------------------------------------------------

' --      
' with CreateObject("Scripting.FileSystemObject") executeGlobal .openTextFile(.getParentFolderName(WScript.ScriptFullName) & "\util.vbs").readAll end with
' uac_test

const UAC_PREPARE = 0
const UAC_ESCALATED = 1
const UAC_COMPAT = 2

sub uac_test 
	dim tmp, u, res
	set u = new UAC
	if u.runMode = 0 then
	    tmp = fso.getSpecialFolder(2) & "\" & fso.getTempName
		fso.createFolder(tmp)	
		u.privDir = tmp
		msgbox "before re"
		set res = u.relaunch("/a:1")
		if res("code") <> 0 then
			msgbox res("msg")
		end if
	elseif u.runMode = 1 then
		msgbox "re:" & u.privDir
		u.returnErr 10, ""
	end if
end sub


class UAC

	public privDir

	public runMode ' -- 0 -    , 1 -    , 2 -     (windows xp)

	private lock

	sub class_initialize
		if WScript.arguments.named.exists("uac") then 
			runMode = 1
			privDir = WScript.arguments.named("uac")
			set lock = fso.CreateTextFile(lockFileName)
			lock.writeLine "uac lock file intercept"
'		elseif left(getWindowsVersion, 2) = "6." then ' Windows 7
		elseif not userIsAdministrator then
			runMode = 0
		else
			runMode = 2
		end if
	end sub

	private function lockFileName
		lockFileName = bs(privDir) & "lock"
	end function

	private function retFileName
		retFileName = bs(privDir) & "result"
	end function

	public sub returnOk
		fso.createTextFile(retFileName).writeLine "0"
	end sub

	public sub returnErr(code, message)
		dim f
		set f = fso.createTextFile(retFileName)
		f.writeLine(code)
		f.writeLine(message)		
	end sub

	private sub cp(src, dst) '   
		dim it, fld, dst1, src1
		src1 = bs(src)
		dst1 = bs(dst)
		set fld = fso.getFolder(src)
		for each it in fld.files
			fso.copyFile it.path, dst1
		next		
		for each it in fld.subFolders
			fso.createFolder dst1 & it.name
			cp src1 & it.name, dst1 & it.name
		next
	end sub

	function relaunch(args)
		set relaunch = relaunchExt(args, true)
	end function

	function relaunchExt(args, cpAll)
		dim fld, it, here, res, iStream, s
		set res = CreateObject("Scripting.Dictionary")
		if IsEmpty(privDir) then _
			Err.raise 1003, "uac.vbs", "   "
		if runMode <> 0 then _
			Err.raise 1004, "uac.vbs", " .   ."
		here = bs(getScriptDir)
		fld = bs(privDir) & "run"
		fso.createFolder fld
		if cpAll then
			cp here, fld
		else
			fso.copyFile WScript.ScriptFullName, fld & "\" & fso.getFileName(WScript.ScriptFullName)
		end if
		fso.CreateTextFile(lockFileName).writeLine "uac lock file initial"
		CreateObject("Shell.Application").ShellExecute WScript.FullName, Chr(34) & _
				fld & "\" & fso.getFileName(WScript.ScriptFullName) & Chr(34) & " /uac:""" & privDir & """ " & args, "", "runas", 1
		do
			WScript.sleep(1000) 
			if not fso.fileExists(lockFileName) then exit do
			on error resume next
				fso.DeleteFile lockFileName
			on error goto 0
		loop    
		if not fso.FileExists(retFileName) then
			res("code") = -1
			res("msg") = "   "
		else
			set iStream = fso.OpenTextFile(retFileName)
			res("code") = iStream.readLine
 			s = ""
			do while not iStream.atEndOfStream
				if s<>"" then s = s & vbCrLf
				s = s & iStream.readLine
			loop
			res("msg") = s
		end if
		set relaunchExt = res
	end function

end class



' ###### use.inc (useLibs, pulled): util #########
'
'$$ use const

dim f_fso
function fso '  --   FileSystemObject   
	if IsEmpty(f_fso) then set f_fso = CreateObject("Scripting.FileSystemObject")
	set fso = f_fso
end function

dim f_shell
function shell '  --   Shell
	if IsEmpty(f_shell) then set f_shell = CreateObject("WScript.Shell")
	set shell = f_shell
end function

function userIsAdministrator

	dim strComputer, fncObjReg, fncStrKeyPath
	strComputer = "."

	' Connect to the registry using WMI
	set fncObjReg = getObject("winmgmts:{impersonationLevel=impersonate}!\\" & strComputer & "\root\default:StdRegProv")

	'The key path to check access to
	fncStrKeyPath = "SYSTEM\CurrentControlSet"

	'Check the users access to delete this component of the registry, and return the result
	fncObjReg.checkAccess HKEY_LOCAL_MACHINE, fncStrKeyPath, REG_DELETE, userIsAdministrator
end function


function getWindowsVersion 
	dim strComputer, objWMIService, colOperatingSystems, objOperatingSystem, res
	res = ""
	strComputer = "."
	Set objWMIService = GetObject("winmgmts:" _
			& "{impersonationLevel=impersonate}!\\" _
			& strComputer & "\root\cimv2")
	Set colOperatingSystems = objWMIService.ExecQuery _
			("Select * from Win32_OperatingSystem")
	For Each objOperatingSystem in colOperatingSystems
		res = objOperatingSystem.Version
		Exit For
	Next
	getWindowsVersion = res
end function

function getScriptDir ' -- ,    
	getScriptDir = fso.getParentFolderName(WScript.ScriptFullName)
end function

function bs(path) ' --  "\"  ,     . 
    dim bss
    bss = right(path,1) = "\" 
	if not bss then 
		path = path & "\"
	end if
	bs = path
end function

function getDriveType(path)  ' --   (0:"Unknown", 1:"Removable", 2:"Fixed", 3:"Network", 4:"CD-ROM", 5:"RAM Disk")
	getDriveType = fso.getDrive(fso.getDriveName(path)).DriveType
end function

function isNetworkPath(path) ' -- ,    
	isNetworkPath = getDriveType(path) = 3
end function


function expandWildcard(path) ' --       ()
	dim re, fld, name, fl, esc, i, s, res, flname
	set res = CreateObject("Scripting.Dictionary")
	fld = fso.getParentFolderName(path)
	name = fso.getFileName(path)
	esc = ".[](){}+"
	for i = 1 to len(esc) 
		s = mid(esc, i, 1)
		name = replace(name, s, "\" & s)
	next
	name = "^" & replace(name, "*", ".*") & "$"
	set re = new RegExp
	re.ignoreCase = true
	re.pattern = name
	for each fl in fso.getFolder(fld).files
		flname = fl.name
		if re.test(flname) then 
			res(bs(fld) & flName) = 1
		end if
	next
	expandWildcard = res.keys()
end function

' Reads a REG_SZ value from the local computer's registry using WMI.
' Parameters:
'   RootKey - The registry hive (see http://msdn.microsoft.com/en-us/library/aa390788(VS.85).aspx for a list of possible values).
'   Key - The key that contains the desired value.
'   Value - The value that you want to get.
'   RegType - The registry bitness: 32 or 64.
'
function readRegStr (rootKey, key, value, regType)
    dim oCtx, oLocator, oReg, oInParams, oOutParams

    set oCtx = createObject("WbemScripting.SWbemNamedValueSet")
    oCtx.add "__ProviderArchitecture", regType

    set oLocator = createObject("Wbemscripting.SWbemLocator")
    set oReg = oLocator.connectServer("", "root\default", "", "", , , , oCtx).get("StdRegProv")

    set oInParams = oReg.methods_("GetStringValue").inParameters
    oInParams.hDefKey = rootKey
    oInParams.sSubKeyName = key
    oInParams.sValueName = value

    set oOutParams = oReg.execMethod_("GetStringValue", oInParams, , oCtx)

    readRegStr = oOutParams.sValue
end function



' ###### use.inc (useLibs, pulled): const #########
'
' --- http://msdn.microsoft.com/en-us/library/windows/desktop/aa384911(v=vs.85).aspx

const HKEY_CLASSES_ROOT   = &H80000000
const HKEY_CURRENT_USER   = &H80000001
const HKEY_LOCAL_MACHINE  = &H80000002
const HKEY_USERS          = &H80000003
const HKEY_CURRENT_CONFIG = &H80000005
const HKEY_DYN_DATA       = &H80000006


const REG_KEY_QUERY_VALUE        = &H1
const REG_KEY_SET_VALUE          = &H2
const REG_KEY_CREATE_SUB_KEY     = &H4
const REG_KEY_ENUMERATE_SUB_KEYS = &H8
const REG_KEY_NOTIFY             = &H10
const REG_KEY_CREATE             = &H20
const REG_DELETE                 = &H10000
const REG_READ_CONTROL           = &H20000
const REG_WRITE_DAC              = &H40000
const REG_WRITE_OWNER            = &H80000


dim composed
composed = true

dim oUac
set oUac = new UAC

dim config_dir
sub findConfig
	dim arch, sect
	config_dir = ""
	for each arch in array("HKEY_LOCAL_MACHINE\SOFTWARE", "HKEY_LOCAL_MACHINE\SOFTWARE\Wow6432Node")
		for each sect in array("OpenVPN", "OpenVPN-GUI")
			on error resume next
				config_dir = shell.regRead(arch & "\" & sect & "\config_dir")
			on error goto 0
			if config_dir <> "" then exit sub
		next
	next
end sub
findConfig

if config_dir = "" then
	if msgbox("    OpenVPN." & vbCrLf & vbCrLf & ", OpenVPN     " _
			& vbCrLf & vbCrLf & "   OpenVPN?", vbQuestion + vbOkCancel, " OpenVPN") = vbOk then _
		createObject("Shell.Application").open "http://openvpn.net/index.php/open-source/downloads.html"
	if msgbox("  ? (  OpenVPN)", vbQuestion + vbOkCancel, " OpenVPN") <> vbOk then userCancelled
	findConfig
	if config_dir = "" then 
		msgbox " OpenVPN  .   ", vbCritical, " OpenVPN"
		WScript.quit 255
	end if
end if


dim certSrc
sub findCert
	dim fl, flName, found
	if WScript.arguments.unnamed.length > 0 then
		certSrc = WScript.arguments.unnamed.item(0)
	else
		certSrc = ""
	    for each fl in fso.getFolder(getScriptDir).files
			flName = fl.path
			if lCase(right(flName,4)) = ".p12" then 
				if certSrc <> "" then 
					msgBox "      ." & vbCrLf & vbCrLf & "       ", vbCritical, "  OpenVPN"
					WScript.quit 255
				else
					certSrc = flName
				end if
			end if
		next
		if certSrc = "" then
			msgBox "      ." & vbCrLf & vbCrLf & "       ", vbCritical, "  OpenVPN"
			WScript.quit 255
		end if
	end if
end sub
findCert

sub goUAC
	dim tmp, res, cd
	if oUac.runMode = 0 then
		if msgbox("    .     ?", _	
				vbQuestion + vbOkCancel, "  OpenVPN    ") <> vbOk then userCancelled
	    tmp = fso.getSpecialFolder(2) & "\" & fso.getTempName
		fso.createFolder(tmp)	
		cd = tmp & "\" & fso.getFileName(certSrc)
		fso.copyFile certSrc, cd
		oUac.privDir = tmp
		set res = oUac.relaunchExt(cd, not composed)
		fso.deleteFolder tmp
		if res("code")<> 0 then
			msgbox " ", vbCritical, " OpenVPN"
			WScript.quit 255
		end if
		WScript.quit 0
	end if
end sub
goUAC

sub userCancelled
	if oUac.runMode = UAC_ESCALATED then WScript.quit 254
	msgbox "  ", vbExclamation, " OpenVPN"
	WScript.quit 254
end sub



if not fso.FolderExists(config_dir) then fso.CreateFolder config_dir
if not fso.FolderExists(config_dir & "\comec") then fso.CreateFolder config_dir & "\comec"
fso.copyFile certSrc, config_dir & "\comec\", true

sub createConfigs
	dim proto, server, flName, prefix, fl, s
	prefix = "COMEC-"
	for each fl in fso.getFolder(config_dir).files
		flName = fso.getFileName(fl.path)
		if lCase(left(flName, len(prefix))) = lCase(prefix) and lCase(right(flName, 5)) = ".ovpn" then 
			fso.deleteFile fl.path
		end if
	next

	for each proto in array("tcp", "udp")
		for each server in array("pri", "sec") 
			flName = config_dir & "\COMEC-" & fso.getBaseName(certSrc) & "-" & proto
			if server = "sec" then 
				flName = flName & "-alt"
			else
				flName = flName & "-pri"
			end if
			if server = "pri" and proto = "udp" then 
				flName = flName & " ()"
			end if
			flName = flName & ".ovpn"
			set fl = fso.openTextFile(flName, 2, true)
			fl.writeLine "proto " & proto
			fl.writeLine "client"
			if server = "pri" then
				fl.writeLine "remote vpn.comec92.ru"
			else
				fl.writeLine "remote vpn-alt.comec92.ru"
			end if
			for each s in split("dev tun|ns-cert-type server|comp-lzo|route-method exe", "|") 
				fl.writeLine s
			next
			fl.writeLine "pkcs12 comec/" & fso.getFileName(certSrc)
		next
	next
end sub 
createConfigs

if oUac.runMode = UAC_ESCALATED then oUac.returnOk
msgbox " ", vbInformation, " OpenVPN"
